/****************************************************************************
FILE          : qnx-pulse-client.c
LAST REVISED  : 2009-12-02
SUBJECT       : Program to demonstrate QNX's message passing API.

This program sends a pulse to the indicated server. This program assumes the server is running
on the same node; it is identified by its process ID only.

     Peter C. Chapin
     Computer Information Systems Department
     Vermont Technical College
     Williston, VT 05495
     PChapin@vtc.vsc.edu
****************************************************************************/

#include <stdio.h>
#include <string.h>
#include <sys/netmgr.h>
#include <sys/neutrino.h>
#include <errno.h>

//
// The following function acts as a simple client.
//
void *client( void *arg )
{
    int  channel_id;
    int  connection_id;
    int  pid;

    printf( "Channel ID? :" ); fflush( stdout );
    scanf( "%d", &channel_id );
    printf( "Server PID? :" ); fflush( stdout );
    scanf( "%d", &pid );
    printf( "Establishing connection\n" );
    // Establish a connection with the server.
    connection_id = ConnectAttach( ND_LOCAL_NODE, pid, channel_id, _NTO_SIDE_CHANNEL, 0 );

    // Send a message and wait for the reply. Display result.
    if( MsgSendPulse( connection_id, 10, 42, 420 ) == -1 ) {
        printf( "%s\n", strerror( errno ) ); 
    }

    // Break the connection with the server.
    ConnectDetach( connection_id );
    return NULL;
}
